/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   clocking_block.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CLOCKING_BLOCK_H
#define UHDM_CLOCKING_BLOCK_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class clocking_block : public scope {
  public:
    // Implicit constructor used to initialize all members,
    // comment: clocking_block();
    virtual ~clocking_block() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    clocking_block* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    int VpiInputEdge() const { return vpiInputEdge_; }

    bool VpiInputEdge(int data) { vpiInputEdge_ = data; return true;}

    int VpiOutputEdge() const { return vpiOutputEdge_; }

    bool VpiOutputEdge(int data) { vpiOutputEdge_ = data; return true;}

    const instance* Instance() const { return instance_; }

    bool Instance(instance* data) { instance_ = data; return true;}

    const delay_control* Input_skew() const { return input_skew_; }

    bool Input_skew(delay_control* data) { input_skew_ = data; return true;}

    const delay_control* Output_skew() const { return output_skew_; }

    bool Output_skew(delay_control* data) { output_skew_ = data; return true;}

    const event_control* Clocking_event() const { return clocking_event_; }

    bool Clocking_event(event_control* data) { clocking_event_ = data; return true;}

    VectorOfclocking_io_decl* Clocking_io_decls() const { return clocking_io_decls_; }

    bool Clocking_io_decls(VectorOfclocking_io_decl* data) { clocking_io_decls_ = data; return true;}

    const virtual_interface_var* Prefix() const { return prefix_; }

    bool Prefix(virtual_interface_var* data) { prefix_ = data; return true;}

    const clocking_block* Actual() const { return actual_; }

    bool Actual(clocking_block* data) { actual_ = data; return true;}

    unsigned int VpiType() const final { return vpiClockingBlock; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmclocking_block; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    int vpiInputEdge_ = 0;

    int vpiOutputEdge_ = 0;

    instance* instance_ = nullptr;

    delay_control* input_skew_ = nullptr;

    delay_control* output_skew_ = nullptr;

    event_control* clocking_event_ = nullptr;

    VectorOfclocking_io_decl* clocking_io_decls_ = nullptr;

    virtual_interface_var* prefix_ = nullptr;

    clocking_block* actual_ = nullptr;

  };

  
  class clocking_blockFactory {
  friend Serializer;
  public:
  clocking_block* Make() {
    clocking_block* obj = new clocking_block();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<clocking_block*> objects_;
  };
  
  
  class VectorOfclocking_blockFactory {
  friend Serializer;
  public:
  std::vector<clocking_block*>* Make() {
    std::vector<clocking_block*>* obj = new std::vector<clocking_block*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<clocking_block*>*> objects_;
  };

};

#endif
