/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   constraint_ordering.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CONSTRAINT_ORDERING_H
#define UHDM_CONSTRAINT_ORDERING_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class constraint_ordering : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: constraint_ordering();
    virtual ~constraint_ordering() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    constraint_ordering* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    VectorOfexpr* Solve_befores() const { return solve_befores_; }

    bool Solve_befores(VectorOfexpr* data) { solve_befores_ = data; return true;}

    VectorOfexpr* Solve_afters() const { return solve_afters_; }

    bool Solve_afters(VectorOfexpr* data) { solve_afters_ = data; return true;}

    unsigned int VpiType() const final { return vpiConstraintOrdering; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmconstraint_ordering; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    VectorOfexpr* solve_befores_ = nullptr;

    VectorOfexpr* solve_afters_ = nullptr;

  };

  
  class constraint_orderingFactory {
  friend Serializer;
  public:
  constraint_ordering* Make() {
    constraint_ordering* obj = new constraint_ordering();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<constraint_ordering*> objects_;
  };
  
  
  class VectorOfconstraint_orderingFactory {
  friend Serializer;
  public:
  std::vector<constraint_ordering*>* Make() {
    std::vector<constraint_ordering*>* obj = new std::vector<constraint_ordering*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<constraint_ordering*>*> objects_;
  };

};

#endif
